unit WordTokenizer;


////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
//                 WordTokenizer
//                                      Version 0.5
//
//
//      Description:
//              ʓIȌR[hPPʂŃg[Nɕ܂B
//              ݒŉ̓IvVwł܂B
//
//
//      LastUpdate: 04/12/27
//      Copyright(C)2004 by Noradaiko
//      HP: http://nora.rurula.com/
////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////

interface

uses Windows, SysUtils, Classes;



const

{*** ݒ ***}

// ͂̃XLbv
TOKEN_SKIP_COMMENT = true;	// Rg
TOKEN_SKIP_SPACE   = false;	// Xy[X

// Rg̎ʎq
TOKEN_WORD_COMMENT = '//';
TOKEN_WORD_COMMENT_LENGTH = Length(TOKEN_WORD_COMMENT);

// ̃uPbg()
TOKEN_STRING_BRACKET = '"''';
TOKEN_STRING_BRACKET_COUNT = Length(TOKEN_STRING_BRACKET);

// ̃uPbg͂
TOKEN_STRING_BRACKET_CUT = false;

var
// Zq
TOKEN_OPERATOR: TStrings;
TOKEN_OPERATOR_COUNT: integer = 0;

{*** ݒI ***}

const

{ P^Cv }
WT_None        =-1;
WT_Unknown     =0;      // `ʎq
WT_Identifier  =1;      // ʎq
WT_Space       =2;      // Xy[X
WT_Numerical   =3;      // l
WT_Symbol      =4;      // L
WT_String      =5;      // (TagɃuPbgԍ)
WT_Comment     =6;      // Rg
WT_Operator    =7;      // Zq


type


{ P }

// P
TWordToken=record
  Pos:          integer;               // ʒu
  Length:       integer;               // 
  Line:         integer;               // sԍ
  WordType:     integer;	       // P^Cv
  Str:          widestring;            // Ee
  Tag:          integer;               // ėp
end;

// g[NXg
TWordTokenArray=array of TWordToken;

// Zq̓o^
procedure RegisterOperator(id: string);


function IsNumerical(c: widechar): boolean;
function IsSymbol(c: widechar): boolean;
function IsStringBracket(w: widechar): boolean;


// g[NXg쐬
function Tokenize(s: widestring): TWordTokenArray;
function Tokenize2(ta: TWordTokenArray): TWordTokenArray;

// }N
function SetToken(const Pos, Length, Line, WordType: integer; const Str: string): TWordToken;
function GetTokenString(const token: TWordTokenArray; st:integer=0; cnt: integer=-1): widestring;
function SubToken(const token: TWordTokenArray; st, cnt: integer): TWordTokenArray;
function ConcatToken(const t1, t2: TWordTokenArray): TWordTokenArray;
function DelToken(const token: TWordTokenArray; st, cnt: integer): TWordTokenArray;
function IndexOfToken(const token: TWordTokenArray; str: string; WordType, start: integer): integer;
// [hAw肵P^CvƕȂTrueԂ
function ConfirmToken(w: TWordToken; WordType: integer; str: string): boolean;
// uPbgO
function ExtractBracket(const s: widestring): widestring;


implementation




function IsNumerical(c: widechar): boolean;
begin
    case c of
    '0','1','2','3','4','5','6','7','8','9': Result:=True;
    else
      Result:=False;
    end;
end;

function IsSymbol(c: widechar): boolean;
begin
    case c of
    '/','+','-','*','!','?','"','$','#','%','&','''','(',')','=','~','^','|','\',';',':','@','`','[',']','{','}','<','>',',','.':
      Result:=True;
    else
      Result:=False;
    end;
end;

function IsStringBracket(w: widechar): boolean;
  var
    i: integer;
begin
    result:=False;
    for i:=1 to TOKEN_STRING_BRACKET_COUNT do
      Result:=Result or (w=Widechar(TOKEN_STRING_BRACKET[i]));
end;




function Tokenize(s: widestring): TWordTokenArray;
var Words: TWordTokenArray;
    wNum: integer;		// [hJE^
    line: integer;

  function AddToken(const w: TWordToken): integer;
  begin
    if not(TOKEN_SKIP_SPACE and (w.WordType=WT_Space)) then
    begin
      Words[wNum]:=w;
      Words[wNum].str:=Copy(s, w.Pos, w.Length);
      Result:=wNum;
      inc(wNum);
    end else
      Result:=-1;
  end;

  { g[N(Result: Iʒu, -1:g[N) }
  function NextToken(const s: widestring; var Line: integer; i: integer; var token: TWordToken): integer;
  var
    c: integer;

    // Xy[X̃g[N
    function TokenizeSpace: TWordToken;
    var
      j: integer;
    begin
        j:=i;
        while (i<=c) and ((s[i]=' ')or(s[i]='@')or(s[i]=#9)) and (s[i]<>#13) do inc(i);
        Result:=SetToken(j, i-j, Line, WT_Space, Copy(s, j, i-j));
    end;

    // ̃g[N
    function TokenizeNumerical: TWordToken;
    var
      dot: boolean;
      j: integer;
    begin
        dot:=false;       // _
        j:=i;

        while (i<=c) and IsNumerical(s[i]) and (s[i]<>#13) do
        begin
          inc(i);
          if (not dot) and (i<=c) and (s[i]='.') then
          begin
            dot:=true;
            inc(i);
          end;
        end;
        if s[i-1]='.' then dec(i);
        Result:=SetToken(j, i-j, Line, WT_Numerical, Copy(s, j, i-j));
    end;

    // ʎq̃g[N
    function TokenizeIdentifiar: TWordToken;
    var
      j: integer;
    begin
        j:=i;
        if (i<=c)and (not (isSymbol(s[i]) or isNumerical(s[i]))) then
        while (i<=c) and (not( (s[i]='@') or (s[i]=' ') or isSymbol(s[i]) or (s[i]=#13) )) do
          inc(i);

        Result:=SetToken(j, i-j, Line, WT_Identifier, Copy(s, j, i-j));
    end;

  begin
    c:=length(s);
    if c>0 then
    begin

      // s
      while (i<=c)and(s[i]=#13) do
      begin
        inc(Line);
        inc(i, 2);
        if i>c then
        begin
          Result:=-1;
          Exit;
        end;
      end;

      // Xy[XE^u
      if (s[i]=' ')or(s[i]='@')or(s[i]=#9) then
          token:=TokenizeSpace

      // 
      else if IsNumerical(s[i]) then
          token:=TokenizeNumerical

      // L
      else if IsSymbol(s[i]) then begin
          token:=SetToken(i,1,Line,WT_Symbol,s[i]);
          inc(i);
      end

      // ʎq
      else
          token:=TokenizeIdentifiar;

    end;
    if token.Length>0 then
      Result:=i
    else
      Result:=-1;
  end;

var
  i, c: integer;
  t: TWordToken;
begin

  s:=AdjustLineBreaks(s);
  c:=Length(s);
  wNum:=0;
  line:=0;
  SetLength(Words, c);	  // LpVeB
  i:=1;

  while(i<=c) do
  begin
    i:=NextToken(s, line, i, t);
    if i>=0 then AddToken(t)
    else break;
  end;

  setLength(Words, wNum);
  Result:=Words;
end;



{ Rgɂg[Ň܂ރg[N }
function Tokenize2(ta: TWordTokenArray): TWordTokenArray;
var
  ret:  TWordTokenArray;
  wNum: integer;		// g[N
  tac: integer;                 // ̃g[N

  procedure addToken(t: TWordToken);
  begin
    ret[wNum]:=t;
    inc(wNum);
  end;
  { Rg }
  function TokenizeComment(var index: integer): boolean;
  var
    j,n: integer;
    s: string;
    b: boolean;
    t: TWordToken;
  begin
    if widestring(TOKEN_WORD_COMMENT[1])=ta[index].Str[1] then
    begin
      s:='';
      b:=false;
      n:=1;

      if TOKEN_WORD_COMMENT_LENGTH>1 then
        for j:=0 to TOKEN_WORD_COMMENT_LENGTH-1 do
        begin
          s:=s+ta[index+j].Str;
          if TOKEN_WORD_COMMENT=s then
          begin
            b:=true;
            break;
          end;
          inc(n);
        end
      else begin
        b:=(TOKEN_WORD_COMMENT=ta[index].Str);
        s:=TOKEN_WORD_COMMENT;
      end;

      // Rgʎq
      if b then
      begin
        j:=index+n;
        while (j<tac)and(ta[index].Line=ta[j].Line) do
        begin
          s:=s+ta[j].str;
          inc(j);
        end;
        
        t.WordType:=WT_Comment;
        t.Str:=s;
        t.Length:=Length(s);
        t.Pos:=ta[index].Pos;
        t.Line:=ta[index].Line;
        if not TOKEN_SKIP_COMMENT then addToken(t);
        index:=j;
        Result:=True;
        exit;
      end;
    end;
    Result:=False;
  end;
  { Zq }
  function TokenizeOperator(var index: integer): boolean;
  var
    i,j,tl,n: integer;
    b: boolean;
    t: TWordToken;
    s: string;
  begin
    if ta[index].WordType<>WT_Numerical then
    for i:=0 to TOKEN_OPERATOR_COUNT-1 do
    if WideString(TOKEN_OPERATOR[i])[1]=ta[index].Str[1] then
    begin
      s:='';
      b:=false;
      tl:=Length(TOKEN_OPERATOR[i]);
      n:=1;

      if tl>1 then
        for j:=0 to tl-1 do
        if index+j<tac then  
        begin
          s:=s+ta[index+j].Str;
          if TOKEN_OPERATOR[i]=s then
          begin
            b:=true;
            break;
          end;
          inc(n);
        end else
        begin
          b:=false;
          break;
        end

      else
        b:=(TOKEN_OPERATOR[i]=ta[index].Str);

      if b then
      begin
        t.WordType:=WT_Operator;
        t.Str:=TOKEN_OPERATOR[i];
        t.Length:=Length(TOKEN_OPERATOR[i]);
        t.Pos:=ta[index].Pos;
        t.Line:=ta[index].Line;
        addToken(t);
        inc(index, n);
        Result:=True;
        exit;
      end;
    end;
    Result:=False;
  end;
  {  }
  function TokenizeString(var index: integer): boolean;
  var
    i,j: integer;
    s: widestring;
    t: TWordToken;
  begin
    for i:=1 to TOKEN_STRING_BRACKET_COUNT do
    if TOKEN_STRING_BRACKET[i]=ta[index].Str then
    begin
      s:=TOKEN_STRING_BRACKET[i];

      for j:=index+1 to tac-1 do
      begin
        s:=s+ta[j].Str;
        if (TOKEN_STRING_BRACKET[i]=ta[j].Str)and(ta[index].Line=ta[j].Line) then
        begin
          t.WordType := WT_String;
          t.Pos      := ta[index].Pos;
          t.Length   := Length(s);
          t.Line     := ta[index].Line;
          t.Tag      := i;
          // uPbg͂
          if TOKEN_STRING_BRACKET_CUT then
            s := Copy(s, 2, Length(s)-2);
          // GXP[v
     //     if i=1 then
       //     s := EscapeChar(s);

          t.Str:=s;
          addToken(t);
          index:=j+1;
          Result:=true;
          exit;
        end;
      end;
    end;
    result:=false;
  end;
  { }CiXCq }
  function TokenizeMinus(ta: TWordTokenArray): TWordTokenArray;
  var
    i,c: integer;
    b: integer;
  begin
    c:=Length(ta);
    i:=c-2;

    while i>=0 do
    begin
      if (ta[i].Str='-')and(i+1<c)and(ta[i+1].WordType=WT_Numerical) then
      begin
        if (i>=2)and(ta[i-1].WordType=WT_Space) then
          b:=2
        else
          b:=1;

        if (i=0) or
           ((ta[i-b].WordType=WT_Operator)or
            (ta[i-b].WordType=WT_Symbol)or
            (ta[i-b].Line<>ta[i].Line)
           ) then
        begin
            ta[i].Str:=ta[i].Str+ta[i+1].Str;
            ta[i].WordType:=WT_Numerical;
            ta:=ConcatToken(SubToken(ta, 0, i+1), SubToken(ta, i+2, c-i-2));
            dec(c);
        end;
      end;

      dec(i);
    end;

    Result:=ta;
  end;

var
  i: integer;
begin
  wNum:=0;
  i:=0;
  tac:=Length(ta);
  SetLength(ret, tac);

  while(i<tac) do
  begin
    if not TokenizeString(i) then
    if not TokenizeComment(i) then
    if not TokenizeOperator(i) then
    begin
      addToken(ta[i]);
      inc(i);
    end;
  end;

  SetLength(ret, wNum);
  //ret:=TokenizeMinus(ret);
  Result:=ret;
end;



function SetToken(const Pos, Length, Line, WordType: integer; const Str: string): TWordToken;
  var r: TWordToken;
begin
  r.Str      := Str;
  r.Pos      := Pos;
  r.Length   := Length;
  r.Line     := Line;
  r.WordType := WordType;
  r.Tag      := 0;
  Result:=r;
end;

function GetTokenString(const token: TWordTokenArray; st:integer=0; cnt: integer=-1): widestring;
var i,c: integer;
  ret: widestring;
begin
  c:=Length(token);
  if (cnt<0)or(c<st+cnt) then
    c:=c-st
  else
    c:=st+cnt;
  ret:='';

    for i:=st to c-1 do
      ret:=ret+token[i].Str;

  Result:=ret;
end;

function SubToken(const token: TWordTokenArray; st, cnt: integer): TWordTokenArray;
var i,c: integer;
  ret: TWordTokenArray;
begin
  c:=Length(token);
  if c>st+cnt then c:=st+cnt;
  SetLength(ret, c-st);

    for i:=st to c-1 do
      ret[i-st]:=token[i];

  Result:=ret;
end;

function ConcatToken(const t1, t2: TWordTokenArray): TWordTokenArray;
var
  ret: TWordTokenArray;
  c2,c1, i: integer;
begin
  ret:=t1;
  c1:=Length(t1);
  c2:=Length(t2);
  SetLength(ret, c1+c2);
  for i:=0 to c2-1 do ret[i+c1]:=t2[i];
  Result:=ret;
end;

function DelToken(const token: TWordTokenArray; st, cnt: integer): TWordTokenArray;
var i,c: integer;
  ret: TWordTokenArray;
begin
  c:=Length(token);
  if c<st+cnt then cnt:=c-st;
  SetLength(ret, c-cnt);

  for i:=0 to st-1 do
    ret[i]:=token[i];
  for i:=st+cnt to c-1 do
    ret[i-cnt]:=token[i];

  Result:=ret;
end;

function ConfirmToken(w: TWordToken; WordType: integer; str: string): boolean;
begin
  Result:=(w.WordType=WordType)and(w.str=str);
end;

function IndexOfToken(const token: TWordTokenArray; str: string; WordType, start: integer): integer;
var
  i,c: integer;
begin
  str:=LowerCase(str);
  c:=Length(token);
  for i:=start to c-1 do
  if ((WordType<0)or(token[i].WordType=WordType))
     and (LowerCase(token[i].Str)=str) then
  begin
    Result:=i;
    Exit;
  end;
  Result:=-1;
end;



// Zq̎ʎqo^
procedure RegisterOperator(id: string);
var i,ln: integer;
begin
  if TOKEN_OPERATOR.IndexOf(id)<0 then
  // ̏ɐĒǉ
  begin
    i:=0;
    ln:=Length(id);
    while(i<TOKEN_OPERATOR_COUNT)do
    begin
      if Length(TOKEN_OPERATOR[i])<ln then break;
      inc(i);
    end;
    TOKEN_OPERATOR.insert(i,id);
  end;          

  TOKEN_OPERATOR_COUNT:=TOKEN_OPERATOR.Count;
end;




// uPbgO
function ExtractBracket(const s: widestring): widestring;
begin
  if (Length(s)>0)and IsStringBracket(widechar(s[1])) then
    Result:=Copy(s, 2, Length(s)-2)
  else
    Result:=s;
end;




initialization

TOKEN_OPERATOR:=TStringList.Create;
TOKEN_OPERATOR_COUNT := 0;


finalization

TOKEN_OPERATOR.Free;

end.
