unit iduoCode;

////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
//                 iduoCode
//                                      Version 0.4
//
//
//      Description:
//              ėpXNvgR[h̎sB
//
//
//      LastUpdate: 06/05/28
//      Copyright(C)2006 by Noradaiko
//      HP: http://nora.rurula.com/
////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
interface

uses Windows, Classes, SysUtils, iduoConsts, iduoResource, iduoToken, iduoParser, WordTokenizer;



type

EProcedureError = ETokenError;

const

// ߂l
IDUO_SUCCESS    = -1;
IDUO_ERROR      = 0;
IDUO_CTRL_BREAK = 1;
IDUO_CTRL_EXIT  = 2;

// XNvgs
function ExecuteProcedure(code: widestring; mem: TVarMemory; var return: TVar): integer; overload;
function ExecuteProcedure(code: TWordTokenArray; mem: TVarMemory; var return: TVar): integer; overload;

// ֐ēo^
procedure RegisterFunctions(code: widestring; funcs: TFunctions); overload;
procedure RegisterFunctions(code: TWordTokenArray; funcs: TFunctions); overload;


type

TIduo = class(TComponent)
private
    mem: TVarMemory;
    FFuncs: TFunctions;
    FScript: WideString;
    FTokens: TWordTokenArray;
  procedure SetScript(v: WideString);
  procedure SetScriptTokens(v: TWordTokenArray);
public
  constructor Create(AOwner: TComponent); override;
  destructor Destroy; override;
  procedure Execute(var return: TVar);
  procedure LoadFromFile(fn: TFileName);
  property Funcs: TFunctions read FFuncs;
  property Memory: TVarMemory read mem;
published
  property Script: WideString read FScript write SetScript;
  property Tokens: TWordTokenArray read FTokens write SetScriptTokens;
end;


implementation

uses Variants;


function IsItTrue(s: variant): boolean;
begin
  if VarType(s)=varBoolean then
    Result:=s
  else if s='0' then
    Result:=False
  else if string(s)='' then
    Result:=False
  else if s<>0 then
    Result:=True
  else
    Result:=True;
end;


function NextSentence(const t: TWordTokenArray; index: integer; var len: integer; skip: boolean; mem: TVarMemory; var return: TVar): integer;
var
  tac: integer;

    function SkipSpace(var index: integer): integer;
    begin
      if (index<tac)and(t[index].WordType=WT_Space) then
      begin
        inc(index);
        Result:=1;
      end else
        Result:=0;
    end;

    function IsCondition(const cn: TWordTokenArray): variant;
    var
      len: integer;
      res: TVar;
    begin
          // 
          if skip then
            result:=false
          else begin
            NextSentence(cn, 0, len, false, mem, res);
            Result:=GetVarValue(res, false);
          end;
    end;

    { ubNs }
    function BlockCode(index: integer; var len: integer): integer;
    var
      i, nc: integer;
    begin
      len:=0;
      i:=index;
      nc:=0;

      while(i<tac)do
      begin
        if t[i].Str='{' then inc(nc);
        if t[i].Str='}' then dec(nc);
        if nc=0 then break;
        inc(i);
      end;

      if nc=0 then len:=i+1-index;
      if len>0 then
        if not skip then
          Result:=ExecuteProcedure(SubToken(t, index+1, len-2), mem, return)
        else
          Result:=IDUO_SUCCESS
      else
        Result:=IDUO_ERROR;
    end;

    { ꕶs }
    function OneSentence(index: integer; var len: integer): integer;
    var
      i: integer;
      pt: TWordTokenArray;
      ret: TProcToken;
    begin
      pt:=nil;
      len:=0;
      i:=index;
      while(i<tac)do
      begin
        if t[i].Str=';' then
        begin
          len:=i+1-index;
          pt:=SubToken(t, index, len-1);
          break;
        end;

        inc(i);
      end;

      if (index=0)and(i=tac) then
      begin
        len:=tac;
        pt:=t;
      end;
      if (len>0) then
      begin
        if not skip then
        begin
          ZeroMemory(@ret, sizeof(TProcToken));
          ParseProc(pt, mem, ret);
          SetVar(return, ret.value);
          FreeToken(ret);
          Result:=IDUO_SUCCESS;
        end else
          Result:=IDUO_SUCCESS;
      end else
        Result:=IDUO_ERROR;
    end;

    { Return  }
    function ReturnSentence(index: integer; var len: integer): integer;
    var
      i: integer;
      ret: TProcToken;
    begin
      len:=0;
      i:=index;
      // ";"
      while(i<tac)do
      begin
        if t[i].Str=';' then
        begin
          len:=i+1-index;
          break;
        end;
        inc(i);
      end;

      if (len>0) then
      begin
        if not skip then
        begin
          ZeroMemory(@ret, sizeof(TProcToken));
          ParseProc(SubToken(t, index+1, len-2), mem, ret);
          SetVar(return, ret.Value);
          FreeToken(ret);
          Result:=IDUO_CTRL_EXIT
        end else
          Result:=IDUO_SUCCESS;
      end else
        Result:=IDUO_ERROR;
    end;

    { function  }
    function FunctionSentence(index: integer; var len: integer): integer;
    var
      i, j: integer;
    begin
      len:=0;
      // ̊
      if t[index+3].Str='(' then
      begin
        // I
        i:=IndexOfToken(t, ')', WT_Symbol, index+4);

        if i>0 then
        begin
          inc(i);
          SkipSpace(i);
          if t[i].Str='{' then
          begin
            NextSentence(t, i, j, True, mem, return);
            i:=i+j;
            len:=i-index;
            Result:=IDUO_SUCCESS;
          end else
            Result:=IDUO_ERROR;
        end else
          Result:=IDUO_ERROR;
      end else
        Result:=IDUO_ERROR;
    end;

    { If }
    function IfSentence(index: integer; var len: integer): integer;
    var
      i, j: integer;
      con: variant;
      ret: TProcToken;
    begin
      Result:=IDUO_ERROR;

      len:=0;
      i:=index;

      if not(LowerCase(t[i].Str)='if') then Exit;
      inc(i); SkipSpace(i);
      if not(t[i].Str='(') then Exit;
      if i<tac then
      begin
        con:='';
        j:=NestProcToken(t, i);

        // 
        if skip then
          con:=false
        else begin
          ZeroMemory(@ret, sizeof(TProcToken));
          ParseProc(SubToken(t, i+1, j-2), mem, ret);
          con:=GetVarValue(ret.value, false);
          FreeToken(ret);
        end;
        inc(i, j);

          // s
          Result:=NextSentence(t, i,j, not IsItTrue(con), mem, return);
          inc(i, j);
          SkipSpace(i);
          // 
          if (Result=IDUO_SUCCESS)and(i<tac)and(LowerCase(t[i].Str)='else') then
          begin
            inc(i);
            SkipSpace(i);
            Result:=NextSentence(t, i,j, skip or IsItTrue(con), mem, return);
            inc(i, j);
          end;

        len:=i-index;
        if len=0 then Result:=IDUO_ERROR;
      end;
    end;

    { WhileJԂ }
    function WhileSentence(index: integer; var len: integer): integer;
    var
      i, j, n: integer;
      ct: TWordTokenArray;
      con: string;
    begin
      Result:=IDUO_ERROR;
      len:=0;
      ct:=nil;
      i:=index;

      if not(LowerCase(t[i].Str)='while') then Exit;
      inc(i);
      SkipSpace(i);
      if not(t[i].Str='(') then Exit;

      if i<tac then
      begin
        con:='';
        j:=NestProcToken(t, i);

        ct:=SubToken(t, i+1, j-2);
        inc(i, j);
        // JԂs
        if not skip then
        begin
          // s̒nɓ邽߈xXLbvs
          NextSentence(t, i, n, true, mem, return);
          // while{
          while(IsItTrue(IsCondition(ct))) do
          begin

            case NextSentence(t, i,j, false, mem, return) of
            IDUO_CTRL_BREAK: break;
            IDUO_CTRL_EXIT:
              begin
                Result:=IDUO_CTRL_EXIT;
                Exit;
              end;
            end;

          end;

          Result:=IDUO_SUCCESS
        end else
          Result:=NextSentence(t, i, n, true, mem, return);

          inc(i, n);
          SkipSpace(i);

        len:=i-index+1;
      end else
        Result:=IDUO_ERROR;

      if len=0 then Result:=IDUO_ERROR;
    end;


    { forJԂ }
    function ForSentence(index: integer; var len: integer): integer;
    var
      i, j: integer;
      cn, fin: TWordTokenArray;
      con: string;
      ret: TProcToken;
    begin
      Result:=IDUO_ERROR;
      len:=0;
      cn:=nil;
      fin:=nil;
      i:=index;

      if not(LowerCase(t[i].Str)='for') then Exit;
      inc(i);
      SkipSpace(i);
      if not(t[i].Str='(') then Exit;

      if i<tac then
      begin
        con:='';
        j:=NestProcToken(t, i);

        cn:=SubToken(t, i+1, j-2);
        inc(i, j);

        // s
        NextSentence(cn, 0, j, skip, mem, return);
        cn:=SubToken(cn, j, Length(cn));
        NextSentence(cn, 0, j, true, mem, return);
        fin:=SubToken(cn, j, Length(cn));
        cn:=SubToken(cn, 0, j-1);

        // JԂs
        if not skip then
        begin
          while IsItTrue(IsCondition(cn)) do
          begin

            case NextSentence(t, i,j, false, mem, return) of
            IDUO_CTRL_BREAK: break;
            IDUO_CTRL_EXIT:
              begin
                Result:=IDUO_CTRL_EXIT;
                Exit;
              end;
            end;

            ZeroMemory(@ret, sizeof(TProcToken));
            ParseProc(fin, mem, ret);
            FreeToken(ret);
          end;

          Result:=IDUO_SUCCESS;
        end else
          Result:=NextSentence(t, i,j, true, mem, return);

          inc(i, j);
          SkipSpace(i);

        len:=i-index;
      end else
        Result:=IDUO_ERROR;

      if len=0 then
        Result:=IDUO_ERROR;
    end;

    { ForeachJԂ }
    function ForeachSentence(index: integer; var len: integer): integer;
    var
      i, j, q, c, n: integer;
      ct: TWordTokenArray;
      arg, val, key: PVar;
      arr: TVarArray;
      con: string;
    begin
      Result:=IDUO_ERROR;
      len:=0;
      ct:=nil;
      SetLength(arr, 0);
      i:=index;

      if not(LowerCase(t[i].Str)='foreach') then Exit;
      inc(i);
      SkipSpace(i);
      if not(t[i].Str='(') then Exit;

      if i<tac then
      begin
        con:='';
        j:=NestProcToken(t, i);

        ct:=SubToken(t, i+1, j-2);
        inc(i, j);

        // JԂs
        if not skip then
        begin
          // Ώەϐp[X
          q:=IndexOfToken(ct, 'as', WT_Identifier, 0);
          if q<0 then Exit;
          with ProcTokenize(SubToken(ct, 0, q)) do
          begin
            if Count=1 then
              arg := ParseVariable(Items[0]^, mem, true)
            else
              arg := nil;
            Free;
          end;
          if not assigned(arg) then Exit;
          inc(q);

          // L[̑ϐw肳Ă邩mF
          j:=IndexOfToken(ct, '=', -1, q);
          if (j>=0)and(IndexOfToken(ct, '>', -1, q)=j+1) then
          begin
            with ProcTokenize(SubToken(ct, q, j-q)) do
            begin
              if Count=1 then
                key := ParseVariable(Items[0]^, mem, true)
              else
                key := nil;
              Free;
            end;
            if not assigned(key) then Exit;
            q:=j+2;
          end else
            key := nil;

          // l̑ϐp[X
          with ProcTokenize(SubToken(ct, q, Length(ct)-q)) do
          begin
            if Count=1 then
              val := ParseVariable(Items[0]^, mem, true)
            else
              val := nil;
            Free;
          end;
          if not assigned(val) then Exit;


          // s̒nɓ邽߈xXLbvs
          NextSentence(t, i, n, true, mem, return);
          // foreach{
          arr := GetVarArray(arg^); 
          c:=Length(arr);
          for q:=0 to c-1 do 
          begin
            if assigned(key) then SetVar(key^, arr[q].Key);
            SetVar(val^, arr[q]);

            case NextSentence(t, i,j, false, mem, return) of
            IDUO_CTRL_BREAK: break;
            IDUO_CTRL_EXIT:
              begin
                Result:=IDUO_CTRL_EXIT;
                Exit;
              end;
            end;

          end;
          
          Result:=IDUO_SUCCESS
        end else
          Result:=NextSentence(t, i, n, true, mem, return);

          inc(i, n);
          SkipSpace(i);

        len:=i-index+1;
      end else
        Result:=IDUO_ERROR;

      if len=0 then Result:=IDUO_ERROR;
    end;


    function ControlSentence(index: integer; var len: integer): integer;
    var
      i: integer;
    begin
      if LowerCase(t[index].Str)='break' then
        Result:=IDUO_CTRL_BREAK
      else if LowerCase(t[index].Str)='exit' then
        Result:=IDUO_CTRL_EXIT
      else
        Result:=IDUO_ERROR;
        
      if skip then
        Result:=IDUO_SUCCESS;

      i:=index+1;
      SkipSpace(i);
      if t[i].str=';' then
        len:=i-index+1
      else
        Result:=IDUO_ERROR;
    end;

var
  i, ret: integer;
begin

    tac:=Length(t);
    i:=index;
    while (index<tac)and(t[index].WordType=WT_Space) do inc(index);

    if index<tac then
    begin
      if t[index].Str='{' then
        ret:=BlockCode(index, len)
      else if LowerCase(t[index].Str)='if' then
        ret:=IfSentence(index, len)
      else if LowerCase(t[index].Str)='while' then
        ret:=WhileSentence(index, len)
      else if LowerCase(t[index].Str)='for' then
        ret:=ForSentence(index, len)
      else if LowerCase(t[index].Str)='foreach' then
        ret:=ForeachSentence(index, len)
      else if LowerCase(t[index].Str)='return' then
        ret:=ReturnSentence(index, len)
      else if LowerCase(t[index].Str)='function' then
        ret:=FunctionSentence(index, len)
      else if LowerCase(t[index].Str)='break' then
        ret:=ControlSentence(index, len)
      else if LowerCase(t[index].Str)='exit' then
        ret:=ControlSentence(index, len)
      else
        ret:=OneSentence(index, len);
    end else
    begin
      len:=0;
      ret:=IDUO_SUCCESS;
    end;

    case ret of
    IDUO_ERROR:
      raise EProcedureError.Create('sȍ\', t[index].Str, t[index].pos, t[index].Line);
    end;

  inc(index, len);
  SkipSpace(index);
  len:=index-i;
  Result:=ret;
end;



function ExecuteProcedure(code: widestring; mem: TVarMemory; var return: TVar): integer;
begin
  Result:=ExecuteProcedure(tokenize2(tokenize(code)), mem, return);
end;


function ExecuteProcedure(code: TWordTokenArray; mem: TVarMemory; var return: TVar): integer;
var
  tac: integer;
  i,j: integer;
begin
  return:=MakeNullVar;

  tac:=Length(code);
  i:=0;
  while(i<tac)do
  begin
    // Es
    Result:=NextSentence(code, i, j, false, mem, return);
    case Result of
    IDUO_CTRL_BREAK, IDUO_CTRL_EXIT: Exit;
    end;

    inc(i, j);
    if j=0 then break;
  end;

  Result:=IDUO_SUCCESS;
end;



procedure RegisterFunctions(code: widestring; funcs: TFunctions);
begin
  RegisterFunctions(tokenize2(tokenize(code)), funcs);
end;

procedure RegisterFunctions(code: TWordTokenArray; funcs: TFunctions);

   function SkipSpace(var index: integer): integer;
   var tac: integer;
   begin
     tac:=Length(code);
     if (index<tac)and(code[index].WordType=WT_Space) then
     begin
       inc(index);
       Result:=1;
     end else
       Result:=0;
   end;

var
  i, len: integer;
  argCount: integer;
  name: string;
  v: TVar;
  ArgNames: TFunctionArgumentNames;
begin

  i:=0;
  repeat
    // function
    i:=IndexOfToken(code, 'function', WT_Identifier, i);
    if i>=0 then
    begin
      // ֐
      inc(i); SkipSpace(i);
      name:=code[i].Str;
      inc(i); SkipSpace(i);
      // 
      if code[i].Str='(' then
      begin
        ArgCount:=0;
        SetLength(ArgNames, 128);
        inc(i); SkipSpace(i);
        while code[i].Str='$' do
        begin
          inc(argCount);
          ArgNames[argCount-1]:=code[i+1].Str;
          inc(i, 2);
          SkipSpace(i);
          
          if code[i].Str=')' then break;
          if code[i].Str=',' then
            inc(i)
          else
            abort;
            
          SkipSpace(i);
        end;
        SetLength(ArgNames, argCount);

        inc(i);
        if code[i].Str='{' then
        begin
          // s
          NextSentence(code, i, len, true, nil, v);
          // o^
          funcs.EntryFunction(name, argCount, SubToken(code, i, len), ArgNames);
          inc(i, len);
        end else
          raise ETokenError.Create('֐̎܂', code[i].Str, code[i].Pos, code[i].Line);

      end else
        raise ETokenError.Create('sȕ', code[i].Str, code[i].Pos, code[i].Line);

    end;
  until i<0;
end;







/////////////////////////////////// TIduo ///////////////////////////////

constructor TIduo.Create(AOwner: TComponent);
begin
  mem    :=TVarMemory.Create;
  FFuncs :=TFunctions.Create;
  FScript:='';
  Functions.AddSubFunction(FFuncs);
  inherited Create(AOwner);
end;

destructor TIduo.Destroy;
begin
  Functions.DeleteSubFunction(funcs);
  mem.Free;
  FFuncs.Free;
  inherited Destroy;
end;

procedure TIduo.LoadFromFile(fn: TFileName);
var
  s: TStringList;
begin
  s:=TStringList.Create;
  s.LoadFromFile(fn);
  Script:=s.Text;
  s.Free;
end;

procedure TIduo.SetScript(v: WideString);
begin
  FScript := v;
  FTokens := tokenize2(tokenize(v));    // g[N
  funcs.ClearEntries;
  RegisterFunctions(FTokens, funcs);    // ֐o^
end;

procedure TIduo.SetScriptTokens(v: TWordTokenArray);
begin
  FScript := GetTokenString(v);
  FTokens := v;
  funcs.ClearEntries;
  RegisterFunctions(FTokens, funcs);    // ֐o^
end;

procedure TIduo.Execute(var return: TVar);
begin
  ExecuteProcedure(tokens, mem, return);
end;


end.
