unit iduoMounting;

interface

uses SysUtils, iduoConsts, iduoResource;


{ Z }
procedure divide(aLeft, aRight: TVar; var aReturn: TVar);         //   /  Z
procedure multip(aLeft, aRight: TVar; var aReturn: TVar);         //   *  |Z
procedure plus(aLeft, aRight: TVar; var aReturn: TVar);           //   +  Z
procedure minus(aLeft, aRight: TVar; var aReturn: TVar);          //   -  Z
procedure concat(aLeft, aRight: TVar; var aReturn: TVar);         //   .  񌋍
procedure divideint(aLeft, aRight: TVar; var aReturn: TVar);      //   \  Z

procedure increment(aLeft, aRight: TVar; var aReturn: TVar);      //   ++ CNg
procedure decrement(aLeft, aRight: TVar; var aReturn: TVar);      //   -- fNg

{ Z }
procedure subst(aLeft, aRight: TVar; var aReturn: TVar);          //   =  
procedure substPlus(aLeft, aRight: TVar; var aReturn: TVar);      //   += 
procedure substMinus(aLeft, aRight: TVar; var aReturn: TVar);     //   -= 
procedure substConcat(aLeft, aRight: TVar; var aReturn: TVar);    //   .= 

{ rZ }
procedure equal(aLeft, aRight: TVar; var aReturn: TVar);          //   == 
procedure nequal(aLeft, aRight: TVar; var aReturn: TVar);         //   != s
procedure bigger(aLeft, aRight: TVar; var aReturn: TVar);         //   >  Ȃ
procedure smaller(aLeft, aRight: TVar; var aReturn: TVar);        //   <  Ȃ
procedure more(aLeft, aRight: TVar; var aReturn: TVar);           //   >= ȏ
procedure less(aLeft, aRight: TVar; var aReturn: TVar);           //   <= ȉ

{ rbgZ }
procedure not_bit(aLeft, aRight: TVar; var aReturn: TVar);        //   !  NOTZ
procedure or_bit(aLeft, aRight: TVar; var aReturn: TVar);         //   |  OR
procedure and_bit(aLeft, aRight: TVar; var aReturn: TVar);        //   &  AND
procedure nor_bit(aLeft, aRight: TVar; var aReturn: TVar);        //   ^  XOR

{ ̑Z }
procedure sizeof(aLeft, aRight: TVar; var aReturn: TVar);         //   sizeof l̃TCY




implementation

uses Variants;



procedure divide(aLeft, aRight: TVar; var aReturn: TVar);         //   /
begin
  SetVar(aReturn, GetVarValue(aLeft, 0)/GetVarValue(aRight, 0));
end;

procedure multip(aLeft, aRight: TVar; var aReturn: TVar);         //   *
begin
  SetVar(aReturn, GetVarValue(aLeft, 0)*GetVarValue(aRight, 0));
end;

procedure plus(aLeft, aRight: TVar; var aReturn: TVar);           //   +
begin
  SetVar(aReturn, GetVarValue(aLeft, 0)+GetVarValue(aRight, 0));
end;

procedure minus(aLeft, aRight: TVar; var aReturn: TVar);          //   -
begin
  SetVar(aReturn, GetVarValue(aLeft, 0)-GetVarValue(aRight, 0));
end;

procedure concat(aLeft, aRight: TVar; var aReturn: TVar);         //   .
begin
  SetVar(aReturn, string(GetVarValue(aLeft, ''))+string(GetVarValue(aRight, '')));
end;

procedure divideint(aLeft, aRight: TVar; var aReturn: TVar);      // \
begin
  SetVar(aReturn, Round(GetVarValue(aLeft, 0)/GetVarValue(aRight, 0)));
end;

procedure subst(aLeft, aRight: TVar; var aReturn: TVar);          //   =
begin
  SetVar(aReturn, aRight);
end;

procedure substPlus(aLeft, aRight: TVar; var aReturn: TVar);      //   += 
begin
  plus(aLeft, aRight, aReturn);
end;

procedure substMinus(aLeft, aRight: TVar; var aReturn: TVar);     //   -= 
begin
  minus(aLeft, aRight, aReturn);
end;

procedure substConcat(aLeft, aRight: TVar; var aReturn: TVar);    //   .= 
begin
  concat(aLeft, aRight, aReturn);
end;


procedure increment(aLeft, aRight: TVar; var aReturn: TVar);      //   ++
begin
  SetVar(aReturn, GetVarValue(aLeft, 0)+1);
end;

procedure decrement(aLeft, aRight: TVar; var aReturn: TVar);      //   --
begin
  SetVar(aReturn, GetVarValue(aLeft, 0)-1);
end;



procedure equal(aLeft, aRight: TVar; var aReturn: TVar);          //   ==
var
  res: boolean;
  va1, va2: PVarArray;
  i,c: integer;
  ret: TVar;
begin
  ret:=MakeNullVar;

  res:=(aLeft.VarType=aRight.VarType);
  if res then
  case aLeft.VarType of
  vtValue:
    try
      res:=string(GetVarValue(aLeft, ''))=string(GetVarValue(aRight, ''));
      try
        res:=res or (boolean(GetVarValue(aLeft, false))=boolean(GetVarValue(aRight, false)));
      except
      end;
    except
      res:=false;
    end;
  vtArray:
    begin
      va1:=PVarArray(aLeft.Value);
      va2:=PVarArray(aRight.Value);
      res:=Length(va1^)=Length(va2^);
      c:=Length(va1^);
      for i:=0 to c-1 do
        if res then
        begin
          equal(va1^[i], va2^[i], ret);
          res:=res and GetVarValue(ret, False);
        end;
    end;
  end else
    res:=False;

  SetVar(aReturn, res);
  FreeVar(ret); 
end;

procedure nequal(aLeft, aRight: TVar; var aReturn: TVar);         //   !=
var
  ret: TVar;
begin
  equal(aLeft, aRight, ret);
  SetVar(aReturn, not GetVarValue(ret, False));
  FreeVar(ret);
end;

procedure bigger(aLeft, aRight: TVar; var aReturn: TVar);         //   >
begin
  if GetVarValue(aLeft, 0)>GetVarValue(aRight, 0) then
    SetVar(aReturn, true)
  else
    SetVar(aReturn, false);
end;

procedure smaller(aLeft, aRight: TVar; var aReturn: TVar);        //   <
begin
  if GetVarValue(aLeft, 0)<GetVarValue(aRight, 0) then
    SetVar(aReturn, true)
  else
    SetVar(aReturn, false);
end;

procedure more(aLeft, aRight: TVar; var aReturn: TVar);           //   >=
begin
  if GetVarValue(aLeft, 0)>=GetVarValue(aRight, 0) then
    SetVar(aReturn, true)
  else
    SetVar(aReturn, false);
end;

procedure less(aLeft, aRight: TVar; var aReturn: TVar);           //   <=
begin
  if GetVarValue(aLeft, 0)<=GetVarValue(aRight, 0) then
    SetVar(aReturn, true)
  else
    SetVar(aReturn, false);
end;




procedure not_bit(aLeft, aRight: TVar; var aReturn: TVar);         //   !
begin
  SetVar(aReturn, not GetVarValue(aRight, 0));
end;

procedure or_bit(aLeft, aRight: TVar; var aReturn: TVar);          //   |
begin
  SetVar(aReturn, GetVarValue(aLeft, 0) or GetVarValue(aRight, 0));
end;

procedure and_bit(aLeft, aRight: TVar; var aReturn: TVar);         //   &
begin
  SetVar(aReturn, GetVarValue(aLeft, 0) and GetVarValue(aRight, 0));
end;

procedure nor_bit(aLeft, aRight: TVar; var aReturn: TVar);         //   ^
begin
  SetVar(aReturn, GetVarValue(aLeft, 0) xor GetVarValue(aRight, 0));
end;


procedure sizeof(aLeft, aRight: TVar; var aReturn: TVar);         //   sizeof
begin
  if aRight.VarType = vtValue then
    SetVar(aReturn, System.sizeof(GetVarValue(aRight, 0)))
  else
    SetVar(aReturn, Length(GetVarArray(aRight)));
end;


// z̗vf폜
procedure unset(Args: TFunctionArgument; var return: TVar);
var
  va: PVarArray;
  i,c: integer;
  key: string;
  b: boolean;
begin
  va:=nil;
  if Args[0].VarType=vtarray then
    if assigned(Args[0].Value) then
      va:=PVarArray(Args[0].Value);

  if assigned(va) then
  begin
    key := GetVarValue(Args[1], '');

    b:=False;
    c:=Length(va^);
    for i:=0 to c-1 do
    begin
      if not b and (va^[i].Key = key) then
      begin
        FreeVar(va^[i]);
        b:=True;
      end;
      if b and (i<c-1) then va^[i] := va^[i+1];
    end;
    if b then
      SetLength(va^, c-1);
  end;

  SetVar(return, Args[0]); 
end;


// ϐz񂩂ǂ
procedure isArray(Args: TFunctionArgument; var return: TVar);
begin
  SetVar(return, (Args[0].VarType = vtArray));
end;


// Nullϐ쐬
procedure _Null(Args: TFunctionArgument; var return: TVar);
begin
  SetVar(return, Null);
end;


// z񐶐
procedure _array(Args: TFunctionArgument; var return: TVar);
var
  c,i: integer;
  va: TVarArray;
begin
  c:=Length(Args);
  SetLength(va, c);
  for i:=0 to c-1 do
  begin
    SetVar(va[i], ARgs[i]);
    va[i].Key := IntToStr(i);
  end;
    
  SetVar(return, MakeVarArray('', va));
end;



initialization


Operators.EntryOperator('/', divide,    AT_BOTH_LR, 0);
Operators.EntryOperator('*', multip,    AT_BOTH_LR, 0);
Operators.EntryOperator('+', plus,      AT_BOTH_LR, 1);
Operators.EntryOperator('-', minus,     AT_BOTH_LR, 1);
Operators.EntryOperator('.', concat,    AT_BOTH_LR, 1);
Operators.EntryOperator('\', divideint, AT_BOTH_LR, 0);

Operators.EntryOperator('++', increment, AT_LEFT_LR, 0, OT_Inc);
Operators.EntryOperator('--', decrement, AT_LEFT_LR, 0, OT_Inc);

Operators.EntryOperator('=',  subst,       AT_BOTH_RL, 5, OT_Subst);
Operators.EntryOperator('+=', substPlus,   AT_BOTH_RL, 5, OT_Subst);
Operators.EntryOperator('-=', substMinus,  AT_BOTH_RL, 5, OT_Subst);
Operators.EntryOperator('.=', substConcat, AT_BOTH_RL, 5, OT_Subst);

Operators.EntryOperator('<',  smaller, AT_BOTH_LR, 2);
Operators.EntryOperator('>',  bigger,  AT_BOTH_LR, 2);
Operators.EntryOperator('<=', less,    AT_BOTH_LR, 2);
Operators.EntryOperator('>=', more,    AT_BOTH_LR, 2);

Operators.EntryOperator('==', equal,   AT_BOTH_LR, 3);
Operators.EntryOperator('!=', nequal,  AT_BOTH_LR, 3);

Operators.EntryOperator('!', not_bit,  AT_RIGHT_RL, 0);
Operators.EntryOperator('|', or_bit,   AT_BOTH_LR,  4);
Operators.EntryOperator('&', and_bit,  AT_BOTH_LR,  4);
Operators.EntryOperator('^', nor_bit,  AT_BOTH_LR,  4);

Operators.EntryOperator('sizeof', sizeof,  AT_RIGHT_RL, 0);

Functions.EntryFunction('unset', 2, unset);
Functions.EntryFunction('isarray', 1, isArray);
Functions.EntryFunction('null', 0, _Null);
Functions.EntryFunction('array', -1, _array);


end.
