unit iduoParser;

interface

uses Windows, Classes, SysUtils, WordTokenizer, iduoToken, iduoResource, iduoConsts,
  Variants;


type

EParseProcessError = ETokenError;
EParseFunctionError = ETokenError;


function ParseVariable(var t: TProcToken; const varmem: TVarMemory; assign: boolean=false): PVar;
function ParseStr(const wt: TWordTokenArray; const varmem: TVarMemory): TWordTokenArray;
procedure ParseProc(const wt: TWordTokenArray; const varmem: TVarMemory; var return: TProcToken); overload;
procedure ParseProc(t: TProcTokenList; const varmem: TVarMemory; var return: TProcToken); overload;
procedure ParseFunc(const wt: TWordTokenArray; const varmem: TVarMemory; var return: TProcToken);


implementation


  { Z̎s }
  procedure op(const p: TOperationProc; left, right: TVar; var return: TVar; wt: TWordTokenArray);
  begin
    try
      p(left, right, return);
    except
    on e: EVariantError do
      raise EParseProcessError.Create('Zľ^܂', GetTokenString(wt), wt[0].Pos, wt[0].Line);
    on e: Exception do
      raise EParseProcessError.Create('ZssG['#13#10+e.Message, GetTokenString(wt), wt[0].Pos, wt[0].Line);
    end;
  end;



{ ϐWJ(ϐւ̃|C^Ԃ) }
{ assigńAzvf쐬邩ǂ }
function ParseVariable(var t: TProcToken; const varmem: TVarMemory; assign: boolean=false): PVar;

    // z̃CfbNXw̏I[̒lp[XĎ擾
    function ParseArray(parent: PVar; t: TWordTokenArray; assign: boolean): PVar;
    var
      i: integer;
      p: PVar;
      key, nk: string;
      pt: TProcToken;
      va: TVarArray;
    begin

      if Length(t)>0 then
      begin
        if t[0].Str=MARK_ARRAY[1] then
        begin
          i:=NestProcToken(t, 0, MARK_ARRAY[1], MARK_ARRAY[2])-2;
          // Vvf̒ǉ
          if i=0 then
          begin
            Result:=AddArrayElement(parent^);
          end else
          // CfbNX̃p[X
          begin
            ParseProc(SubToken(t, 1, i), varmem, pt);
            key:=GetVarValue(pt.value, Null);
            if key<>Null then
            try
              // evfz^łȂꍇ́Az
              SetLength(va, 0);
              if parent.VarType<>vtArray then
              begin
                nk:=parent^.Key;
                FreeVar(parent^);
                parent^:=MakeVarArray(nk, va);
              end;

              // wL[̗vf
              p:=ArrayElementOf(PVarArray(parent.Value)^, key);
              // vfȂꍇ́Avfǉ
              if not assigned(p) and assign then
                Result:=AddArrayElement(parent^, key)
              else
                Result:=p;
            except
              raise EParseProcessError.Create('sȃCfbNXw', pt.word[0].Str, pt.word[0].Pos, pt.word[0].Line);
            end else
              raise EParseProcessError.Create('sȃCfbNXw', pt.word[0].Str, pt.word[0].Pos, pt.word[0].Line);

            FreeVar(pt.value);
          end;

          Result:=ParseArray(Result, SubToken(t, i+2, Length(t)), assign);
        end else
          raise EParseProcessError.Create('\ʕ', t[0].Str, t[0].Pos, t[0].Line);
      end else
        Result:=parent;
        
    end;

var
  varname: string;
  preinc, postinc: string;
  p: PVar;
begin
    // CNgZq̒oƍ폜
    if t.word[0].WordType=WT_Operator then
    begin
      preinc:=t.word[0].Str;
      t.word:=SubToken(t.word, 1, Length(t.word)-1);
    end;
    if (t.word[Length(t.word)-1].WordType=WT_Operator) then
    begin
      postinc:=t.word[Length(t.word)-1].Str;
      t.word:=SubToken(t.word, 0, Length(t.word)-1);
    end;

    if t.word[0].Str=MARK_VAR then
    begin
      // ϐuPbgO
      if t.word[1].Str = MARK_VAR_BRACKET[1] then
        t.word:=DelToken(t.word, 1, 1);
      if t.word[Length(t.word)-1].Str = MARK_VAR_BRACKET[2] then
        t.word:=DelToken(t.word, Length(t.word)-1, 1);

      // l擾
      varname:=t.word[1].Str;
      p:=varmem.GetMem(varname);
      p:=ParseArray(p, SubToken(t.word, 2, Length(t.word)-2), assign or(preinc<>'') or(postinc<>''));

      // vECNg
      if preinc<>'' then
        op(Operators.Data[Operators.IndexOf(preinc)].Proc, p^, MakeNullVar(), p^, t.word);

      // ]
      if assigned(p) then
        SetVar(t.value, p^)
      else
        SetVar(t.value, MakeNullVar);
      t.ttype := PT_Value;

      // |XgECNg
      if postinc<>'' then
        op(Operators.Data[Operators.IndexOf(postinc)].Proc, p^, MakeNullVar(), p^, t.word);

      Result:=p;
    end else
      Result:=nil;

end;


{ WJp[T }
function ParseStr(const wt: TWordTokenArray; const varmem: TVarMemory): TWordTokenArray;

    // GXP[v
    function EscapeChar(s: widestring): string;
    var
      c, i: integer;
    begin
      c:=Length(s);
      i:=1;

      if c>1 then
      repeat

        if (i<c)and(s[i]='\') then
        begin
          case s[i+1] of
          'r': s[i]:=#13;
          'n': s[i]:=#10;
          't': s[i]:=#9;
          '\': s[i]:='\';
          else
            s[i]:=s[i+1];
          end;
          Delete(s, i+1, 1);
          c:=Length(s);
        end;
        inc(i);

      until i>=c;

      Result:=s;
    end;

    function ParseVariables(t: TWordTokenArray): string;
    var
      i,j,c: integer;
      ret: TProcToken;
      a: TWordTokenArray;
    begin
      i:=0;
      c:=Length(t);
      while (i<c) do
      begin
        // ϐ
        if t[i].Str=MARK_VAR then
        begin
          SetLength(a, 0);

          if (i+1<c)and(t[i+1].Str=MARK_VAR_BRACKET[1]) then
          begin
            j:=NestProcToken(t, i+1, MARK_VAR_BRACKET[1], MARK_VAR_BRACKET[2]);
            a:=SubToken(t, i, j+1);
            t:=DelToken(t, i, j);
          end else
          if (i+1<c)and(t[i+1].WordType=WT_Identifier)and(t[i].Pos = t[i+1].Pos-1) then
          begin
            j:=1;
            while (i+j+3<c)and(t[i+j+1].Str=MARK_ARRAY[1]) do
            begin
              j:=j+NestProcToken(t, i+j+1, MARK_ARRAY[1], MARK_ARRAY[2]);
            end;

            a:=SubToken(t, i, j+1);
            t:=DelToken(t, i, j);
          end else
            raise ETokenError.Create('sȕ', t[i].Str, t[i].Pos, t[i].Line);

          // ϐ]  
          ZeroMemory(@ret, sizeof(ret));
          ParseProc(a, varmem, ret);
          t[i]:=ret.word[0];
          t[i].WordType := WT_String;
          t[i].Str := GetVarValue(ret.value, '');
          t[i].Length := Length(t[i].Str);
          inc(i);
          FreeToken(ret);
        end else
          inc(i);

        c:=Length(t);
      end;

      Result:=GetTokenString(t);
    end;

var
  s: string;
  t: TWordTokenArray;
begin
  t:=nil;
  if wt[0].Str[1]='"' then
  begin
    s:=Copy(wt[0].Str, 2, Length(wt[0].Str)-2);
    s:=ParseVariables(Tokenize(s));
    wt[0].Str:=''''+EscapeChar(s)+'''';
  end;
  Result:=wt;
end;


procedure ParseProc(const wt: TWordTokenArray; const varmem: TVarMemory; var return: TProcToken);
var
  t: TProcTokenList;
begin
  t:=ProcTokenize(wt);
  ParseProc(t, varmem, return);
  t.Free;
end;

{ Zp[T }
procedure ParseProc(t: TProcTokenList; const varmem: TVarMemory; var return: TProcToken);
type
  TTag = record
    OpIndex: integer;
    Token: PProcToken;
  end;
  PTag = ^TTag;
var
  c, i, lv, j: integer;
  a1, a2: TProcToken;
  ta1, ta2: TProcTokenList;
  ol: array[0..OPERATOR_LEVEL_MAX] of TList;
  oc: integer;
  pt: PTag;
  sv: PVar;
begin

  c:=t.Count;
  if c=0 then Exit;

  { Z }

  // ZXg쐬
  for lv:=0 to OPERATOR_LEVEL_MAX do
    ol[lv]:=TList.Create;

  // Zq()
  for i:=0 to c-1 do
  if t[i].ttype=PT_Operator then
  begin
    j:=Operators.IndexOf(t[i].word[0].Str);
    New(pt);
    pt.OpIndex:=j;      // Zqf[^
    pt.Token:=t[i];     // g[Nԍ

    with Operators.Data[j] do
    case Argtype of
    AT_BOTH_LR, AT_LEFT_LR:  ol[Level].Add(pt);
    AT_BOTH_RL, AT_RIGHT_RL: ol[Level].Insert(0, pt);
    end;
  end;

  // Zs
  for lv:=0 to OPERATOR_LEVEL_MAX do
  begin
    oc:=ol[lv].Count;

    for j:=0 to oc-1 do
    begin
      i:=t.IndexOf(PTag(ol[lv][j]).Token);

          with Operators.Data[PTag(ol[lv][j]).OpIndex] do
          begin
            ZeroMemory(@a1, sizeof(a1));
            ZeroMemory(@a2, sizeof(a2));

            // Zg[N
            ta1 := TProcTokenList.Create;
            ta2 := TProcTokenList.Create;
                       
            // 
            case Argtype of
            AT_BOTH_LR, AT_BOTH_RL, AT_LEFT_LR:
              begin
                // }CiX()Cq
                if (Name='-')and
                   (((i-1>=0)and(t[i-1].ttype=PT_Operator)) or (i-1<0))and
                   (t[i+1].ttype=PT_Value) then
                begin
                  SetLength(a1.word, 1);
                  a1.word[0]:=SetToken(t[i].word[0].Pos, 1, t[i].word[0].Line, WT_Numerical, '0');
                  a1.ttype:=PT_Value;
                  a1.value:=MakeNullVar();
                end else
                if i-1>=0 then
                begin
                  CopyProcToken(a1, t[i-1]^);
                  t.Delete(i-1);
                  dec(i);
                end else
                  raise EParseProcessError.Create('܂', t[i].word[0].Str, t[i].word[0].pos, t[i].word[0].Line);

                ta1.Add(a1);
              end;
            end;


            // E
            case Argtype of
            AT_BOTH_LR, AT_BOTH_RL, AT_RIGHT_RL:
              begin
                if (i+1<c) then
                begin
                  CopyProcToken(a2, t[i+1]^);
                  t.Delete(i+1);
                end else
                  raise EParseProcessError.Create('܂', t[i].word[0].Str, t[i].word[0].pos, t[i].word[0].Line);

                ta2.Add(a2);
              end;
            end;


            // s
            case otype of
            OT_Normal:
              begin
                ZeroMemory(@a1, sizeof(TProcToken));
                ZeroMemory(@a2, sizeof(TProcToken));
                ParseProc(ta1, varmem, a1);
                ParseProc(ta2, varmem, a2);
                // Zs
                op(Proc, a1.value, a2.value, t[i].value, t[i].word);
                t[i].ttype:=PT_Value;
                FreeVar(a1.value);
                FreeVar(a2.value);
              end;
            OT_Subst:
              if a1.ttype=PT_Variable then
              begin
                // ϐւ̃|C^擾
                sv:=ParseVariable(a1, varmem, true);
                ZeroMemory(@a2, sizeof(TProcToken));
                ParseProc(ta2, varmem, a2);
                // Zs
                op(Proc, a1.value, a2.value, t[i].value, t[i].word);
                // 
                SetVar(sv^, t[i].value);
                t[i].ttype:=PT_Value;

                FreeVar(a2.value);
              end else
                raise EParseProcessError.Create('ł܂', t[i].word[0].Str, t[i].word[0].pos, t[i].word[0].Line);
            end;

            ta1.Free;
            ta2.Free;
          end;

      Dispose(ol[lv][j]);   // Z^O̊J
      c:=t.Count;       // g[Nϓ̂ߍXV
    end;

    // XgJ
    ol[lv].free;
  end;


  { ֐Z }
  for i:=0 to c-1 do
  if t[i].ttype=PT_Function then
  begin
    ParseFunc(t[i].word, varmem, t[i]^);
  end;

  {  }
  for i:=0 to c-1 do
  if t[i].ttype=PT_Nest then
    ParseProc(SubToken(t[i].word, 1, Length(t[i].word)-2), varmem, t[i]^);


  for i:=0 to c-1 do
  begin
    case t[i].ttype of
    // ̕ϐWJ
    PT_Value:
      if t[i].word[0].WordType=WT_String then
      begin
        t[i].word  := ParseStr(t[i].word, varmem);
        t[i].value := MakeVar('', Copy(t[i].word[0].Str, 2, Length(t[i].word[0].Str)-2));
      end;
    // ϐWJ
    PT_Variable:
      begin
        ParseVariable(t[i]^, varmem);
      end;
    end;
  end;


  // g[Nȏ
  if t.Count>1 then
  begin
    a1:=t[0]^;
    FreeAndNil(t);
    with a1.word[0] do raise EParseProcessError.Create('sȕ', Str, Pos, Line);
  end else
    CopyProcToken(return, t[0]^);

end;

{ ֐p[T }
procedure ParseFunc(const wt: TWordTokenArray; const varmem: TVarMemory; var return: TProcToken);
var
  tac: integer;

  function ReadArgument(var index: integer): TVar;
  var
    i, n: integer;
    ret: TProcToken;
  begin
    n:=0;
    for i:=index to tac-1 do
    begin
      if wt[i].Str='(' then
        inc(n)
      else if wt[i].Str=')' then
        dec(n);

      if ((n=0)and(wt[i].Str=','))or(n=-1) then
      begin
        if index<i then
        begin
          ZeroMemory(@ret, sizeof(TProcToken));
          ParseProc(SubToken(wt, index, i-index), varmem, ret);
          Result:=ret.value;
          index:=i;
          Exit;
        end else
          raise EParseFunctionError.Create('w肳Ă܂', wt[i].Str, wt[i].Pos, wt[i].Line);

      end;

    end;
    raise EParseFunctionError.Create('܂', wt[index].Str, wt[index].Pos, wt[index].Line);
  end;
var
  Args: TFunctionArgument;
  Func: TFunctionData;
  fn: string;
  i,j,ac: integer;
begin
  tac:=Length(wt);

  // ֐̏
  fn:=LowerCase(wt[0].Str);
  Func:=Functions.GetFunction(fn);
  ac:=Func.ArgCount;
  if ac>0 then
    SetLength(Args, ac)
  else
  // ̐
    SetLength(Args, 255);

  // p[X
  if (tac>2)and (wt[1].Str='(') then
  begin
    j:=2;
    i:=0;
    while (ac<0)or(i<ac) do
    begin
      // ̒lp[X
      Args[i]:=ReadArgument(j);
      // ̏I
      if wt[j].Str=')' then
      begin
        if (ac>0)and(i<ac-1) then
          raise EParseFunctionError.Create('܂', wt[0].Str, wt[0].Pos, wt[0].Line);

        if ac<0 then break;
      end else
      if wt[j].Str=',' then
        inc(j);

      inc(i);
    end;
    if wt[j].Str<>')' then
      raise EParseFunctionError.Create('܂', wt[0].Str, wt[0].Pos, wt[0].Line);

    // ʈz؂
    if ac<0 then
      SetLength(Args, i+1);
  end else
  if ac>0 then
    raise EParseFunctionError.Create('w肵Ă', wt[0].Str, wt[0].Pos, wt[0].Line)
  else
    SetLength(Args, 0);

  // ̐mF
  if (ac<0)and(-ac>Length(Args)) then
    raise EParseFunctionError.Create('܂', wt[0].Str, wt[0].Pos, wt[0].Line);



  // ֐s
  return.ttype:=PT_Value;
  return.word:=wt;
  try
    Functions.Call(fn, Args, return.Value);
  except
  on e: EFunctionExecuteError do
    raise EParseProcessError.Create('֐sG['#13#10+e.Message, GetTokenString(wt), wt[0].Pos, wt[0].Line);
  end;

  // J
  for i:=0 to ac-1 do FreeVar(Args[i]);
end;



end.
