unit iduoResource;

interface

uses Windows, Classes, SysUtils, Variants;


type

TVarType = (vtValue, vtArray);

PVar = ^TVar;
TVar = record
  Key: string;
  Value: Pointer;       // VariantTVarArrayւ̃|C^
  VarType: TVarType;
end;

PVarArray = ^TVarArray;
TVarArray = array of TVar;


TVarMemory = class
private
    fMemCount: integer;			   // ̐
  function GetVar(Name: string): TVar;
  procedure SetVar(Name: string; Content: TVar);
  function NewMem(Content: TVar): integer;
public
    Mems: array of TVar;  
  constructor Create;
  destructor Destroy; override;
  procedure Clear;
  function IndexOf(MemName: string): integer;
  function GetMem(Name: string): PVar;
  property Count: integer read fMemCount;
  property Items[Name: string]: TVar read GetVar write SetVar; default;
end;


function MakeVar(Key: string; Value: variant): TVar;
function MakeVarArray(Key: string; Value: TVarArray): TVar;
procedure SetVar(var Dest: TVar; const Src: TVar); overload;
procedure SetVar(var Dest: TVar; Src: variant); overload;
procedure CopyVar(var Dest: TVar; const Src: TVar);

function AddArrayElement(var content: TVar; Key: string=''): PVar;
function ArrayElementOf(const content: TVarArray; Key: string): PVar;

procedure FreeVar(var content: TVar);
function MakeNullVar(): TVar;
function GetVarValue(content: TVar; def: variant): variant;
function GetVarArray(content: TVar): TVarArray;


implementation



constructor TVarMemory.Create;
begin
  inherited Create;
    SetLength(Mems, 64);
end;

destructor TVarMemory.Destroy;
begin
  Clear;
  inherited Destroy;
end;

procedure TVarMemory.Clear;
var
  i: integer;
begin
  for i:=0 to fMemCount-1 do FreeVar(Mems[i]);
  fMemCount:=0;
end;

function TVarMemory.GetVar(Name: string): TVar;
  var i: integer;
begin
  for i:=0 to Count-1 do
  if Mems[i].Key=Name then
  begin
    Result:=Mems[i];
    Exit;
  end;
  Result:=Mems[NewMem(MakeVar(Name, Null))];
end;

procedure TVarMemory.SetVar(Name: string; Content: TVar);
  var i: integer;
begin
  // ̃ɐݒ
  for i:=0 to Count-1 do
  if Mems[i].Key=Name then
  begin
    if Mems[i].Value<>Content.Value then
      iduoResource.SetVar(Mems[i], Content)
    else
      Mems[i]:=Content;
    Exit;
  end;

  NewMem(Content);
end;


function TVarMemory.NewMem(Content: TVar): integer;
begin
  // VKɐݒ
  try
    inc(fMemCount);
    Mems[Count-1].Key := Content.Key;
    iduoResource.SetVar(Mems[Count-1], Content);
    Result:=Count-1
  except
    // I[o[
    raise Exception.Create('Memory Over Flow.');
  end;
end;

function TVarMemory.IndexOf(MemName: string): integer;
var i: integer;
begin
  // ̃ɐݒ
  for i:=0 to Count-1 do
  if Mems[i].Key=MemName then
  begin
    Result:=i;
    Exit;
  end;
  Result:=-1;
end;


{ lւ̃AhXԂ }
function TVarMemory.GetMem(Name: string): PVar;
var i: integer;
begin
  i:=IndexOf(Name);
  if i>=0 then
    Result:=@Mems[i]
  else
    Result:=@Mems[NewMem(MakeVar(Name, Null))];
end;




{ XJϐ쐬 }
function MakeVar(Key: string; Value: variant): TVar;
begin
  ZeroMemory(@Result, sizeof(TVar)); 
  Result.Key := Key;
  Result.Value := AllocMem(sizeof(variant));
  PVariant(Result.Value)^ := Value;
  Result.VarType := vtValue;
end;

{ XJz쐬 }
function MakeVarArray(Key: string; Value: TVarArray): TVar;
begin
  ZeroMemory(@Result, sizeof(TVar));
  Result.Key := Key;
  Result.Value := AllocMem(sizeof(TVarArray));
  PVarArray(Result.Value)^ := Value;
  Result.VarType := vtArray;
end;

{ XJlRs[ }
procedure SetVar(var Dest: TVar; const Src: TVar);
var
  k: string;
  a: TVarArray;
  p: PvarArray;
  i,c: integer;
begin
  // Rs[f[^ɒl
  if not Assigned(Src.Value) then
  begin
    k:=Dest.Key;
    FreeVar(Dest);
    Dest.Key:=k;
    Exit;
  end;

  SetLength(a, 0);
  // Rs[f[^ɒlA܂̓f[^^Ⴄ
  if (Dest.VarType<>Src.VarType)or not assigned(Dest.Value) then
  begin
    k:=Dest.Key;
    FreeVar(Dest);
    case Src.VarType of
    vtValue: Dest:=MakeVar(k, null);
    vtArray: Dest:=MakeVarArray(k, a);
    end;
  end;

  // l̃Rs[
  case Src.VarType of
  vtValue:
    begin
      PVariant(Dest.Value)^:=PVariant(Src.Value)^;
    end;
  vtArray:
    begin
      c:=Length(PVarArray(Src.Value)^);
      p:=PVarArray(Dest.Value);
      SetLength(p^, c);
      for i:=0 to c-1 do
        CopyVar(p^[i], PVarArray(Src.Value)^[i]);
    end;
  end; 
end;


{ XJϐ̒l }
procedure SetVar(var Dest: TVar; Src: variant);
var
  k: string;
begin
  if (Dest.VarType<>vtValue) or not assigned(Dest.Value) then
  begin
    k:=Dest.Key;
    FreeVar(Dest);
    Dest:=MakeVar(k, Src);
  end else
    PVariant(Dest.Value)^ := Src;
end;


{ L[ꏏɃRs[ }
procedure CopyVar(var Dest: TVar; const Src: TVar);
var
  a: TVarArray;
  p: PvarArray;
  i,c: integer;
begin
  // Rs[f[^ɒl
  if not Assigned(Src.Value) then
  begin
    FreeVar(Dest);
    Dest:=Src;
    Exit;
  end;

  SetLength(a, 0);
  // Rs[f[^ɒlA܂̓f[^^Ⴄ
  if (Dest.VarType<>Src.VarType)or not assigned(Dest.Value) then
  begin
    FreeVar(Dest);
    case Src.VarType of
    vtValue: Dest:=MakeVar(Src.Key, null);
    vtArray: Dest:=MakeVarArray(Src.Key, a);
    end;
  end;

  // l̃Rs[
  case Src.VarType of
  vtValue:
    begin
      PVariant(Dest.Value)^:=PVariant(Src.Value)^;
    end;
  vtArray:
    begin
      c:=Length(PVarArray(Src.Value)^);
      p:=PVarArray(Dest.Value);
      SetLength(p^, c);
      for i:=0 to c-1 do
        CopyVar(p^[i], PVarArray(Src.Value)^[i]);
    end;
  end;
  Dest.Key := Src.Key;
  
end;


{ XJz̗vfǉBꂪzŖꍇ͔z񉻂 }
{ Keyw肵Ȃꍇ́AKeyɃ[琔CfbNX^ }
function AddArrayElement(var content: TVar; Key: string=''): PVar;

  function ThinkElementIndex(const v: TVarArray): string;
  var
    i, c: integer;
  begin
    Result:='';

    c:=Length(v);
    for i:=0 to c do
    if not Assigned(ArrayElementOf(v, IntToStr(i))) then
    begin
      Result:=IntToStr(i);
      break;
    end;
  end;

var
  k: string;
  v: TVarArray;
  p: PVarArray;
begin
  // złȂꍇ́Aϐz
  if content.VarType <> vtArray then
  begin
    k:=content.Key;
    FreeVar(content);
    SetLength(v, 0);
    content:=MakeVarArray(k, v);
  end;

  // Vvfǉ
  p:=content.Value;
  if key='' then key:=ThinkElementIndex(p^); 
  SetLength(p^, Length(p^)+1);
  p^[Length(p^)-1]:=MakeVar(Key, Null);
  
  Result:=@p^[Length(p^)-1];
end;


{ XJz̎wL[̗vfĕԂ }
function ArrayElementOf(const content: TVarArray; Key: string): PVar;
var
  i,c: integer;
begin
  Result:=nil;
  
  c:=Length(content);
  for i:=0 to c-1 do
  if content[i].Key = Key then
  begin
    Result:=@content[i];
    break;
  end;
end;


{ XJϐJ }
procedure FreeVar(var content: TVar);
var
  p: PVarArray;
  i,c: integer;
begin
  // 蓖ĂJ
  if assigned(content.Value) then
  case content.VarType of
  vtValue:
    FreeMem(content.Value, sizeof(TVar));
  vtArray:
    begin
      p:=content.Value;
      c:=Length(p^);
      for i:=0 to c-1 do
        FreeVar(p^[i]);

      Dispose(p);
    end;
  end;

  // Zbg
  ZeroMemory(@content, sizeof(TVar));
end;


function MakeNullVar(): TVar;
begin
  ZeroMemory(@Result, sizeof(TVar));
end;

function GetVarValue(content: TVar; def: variant): variant;
begin
  try
    if content.VarType=vtValue then
      if assigned(content.Value) then
        Result:=PVariant(content.Value)^
      else
        Result:=def
    else
      Result:=def;
  except
    Result:=def;
  end;

  if Result=Null then
    Result:=def;
end;

function GetVarArray(content: TVar): TVarArray;
begin
  SetLength(Result, 0);
  if content.VarType=vtarray then
    if assigned(content.Value) then
      Result:=PVarArray(content.Value)^;
end;



end.
